package nl.amis.view;

import javax.el.ELContext;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;


public class ApplyPersistentChanges implements PhaseListener {
    public ApplyPersistentChanges() {
    }

    public void afterPhase(PhaseEvent phaseEvent) {
    }

    public void beforePhase(PhaseEvent phaseEvent) {
        invokePersistentChangeManager();

    }

    private void invokePersistentChangeManager() {
        // get hold of #{SessionWideChangePersistenceManager} and invoke applyPersistentChanges()
        FacesContext ctx = FacesContext.getCurrentInstance();
        ELContext elCtx  = ctx.getELContext();
        Application app  = ctx.getApplication();
        
        SessionWideChangePersistenceManager mgr = (SessionWideChangePersistenceManager)app.evaluateExpressionGet(ctx, "#{SessionWideChangePersistenceManager}" ,SessionWideChangePersistenceManager.class);
        mgr.applyPersistentChanges();

    }


    public PhaseId getPhaseId() {
        return PhaseId.RENDER_RESPONSE; 
    }
}
