package nl.amis.view;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import org.apache.myfaces.trinidad.change.AttributeComponentChange;
import org.apache.myfaces.trinidad.change.ComponentChange;
import org.apache.myfaces.trinidad.change.SessionChangeManager;

public class SessionWideChangePersistenceManager {

    private Map viewsProcessed = new HashMap();

    public void applyPersistentChanges() {
        applyAllPersistentChanges();
    }

    public String applyAllThePersistentChanges() {

        applyAllPersistentChanges();
        return null;
    }

    public String clearPersistentChanges() {
        clearAllPersistentChanges();
        return null;
    }


    private void applyAllPersistentChanges() {

        if (!viewsProcessed.containsKey(FacesContext.getCurrentInstance().getViewRoot().getViewId())) {
            System.out.println("Apply all Persistent Changes to " +
                               FacesContext.getCurrentInstance().getViewRoot().getViewId());
            Map viewMap =
                getComponentToChangesMapForView(FacesContext.getCurrentInstance(),
                                                FacesContext.getCurrentInstance().getViewRoot().getViewId(),
                                                true);

            if ("/EmpTable.jspx".equalsIgnoreCase(FacesContext.getCurrentInstance().getViewRoot().getViewId())) {
                String uid = "empTablePanelCollection:empTable:colJob";
                AttributeComponentChange acc =
                    new AttributeComponentChange("visible", false);
                addChangesToComponent(uid, viewMap,
                                      new ComponentChange[] { acc });

                String uid2 = "empTablePanelCollection:empTable:colHiredate";
                AttributeComponentChange acc2 =
                    new AttributeComponentChange("visible", false);
                addChangesToComponent(uid2, viewMap,
                                      new ComponentChange[] { acc2 });

                String uid3 = "empTablePanelCollection:empTable:colEname";
                AttributeComponentChange acc3 =
                    new AttributeComponentChange("displayIndex",
                                                 new Integer(2));
                AttributeComponentChange acc4 =
                    new AttributeComponentChange("width", 400);
                AttributeComponentChange acc5 =
                    new AttributeComponentChange("headerText",
                                                 "Name of Employee");
                addChangesToComponent(uid3, viewMap,
                                      new ComponentChange[] { acc3, acc4,
                                                              acc5 });

                String uid4 = "empTablePanelCollection:empTable:colmgr";
                AttributeComponentChange acc6 =
                    new AttributeComponentChange("displayIndex",
                                                 new Integer(1));
                           AttributeComponentChange acc7 =
                    new AttributeComponentChange("width", 400);
                addChangesToComponent(uid4, viewMap,
                                      new ComponentChange[] { acc6, acc7 });
            }
            if ("/goEmp.jspx".equalsIgnoreCase(FacesContext.getCurrentInstance().getViewRoot().getViewId())) {
                String uid = "richTextEditor";
                AttributeComponentChange acc =
                    new AttributeComponentChange("inlineStyle",
                                                 "background-color:Orange;");
                AttributeComponentChange acc1 =
                    new AttributeComponentChange("columns", 250);
                addChangesToComponent(uid, viewMap,
                                      new ComponentChange[] { acc, acc1 });

            }
            viewsProcessed.put(FacesContext.getCurrentInstance().getViewRoot().getViewId(),
                               Boolean.TRUE);
            reportAllComponentChangesForPage(FacesContext.getCurrentInstance().getViewRoot().getViewId());
        }
    }

    public static void addChangesToComponent(String uid, Map viewMap,
                                       ComponentChange[] cc) {
        List changeListForComponent = (List)viewMap.get(uid);
        if (changeListForComponent == null) {
            changeListForComponent = new CopyOnWriteArrayList();
            viewMap.put(uid, changeListForComponent);
        }
        for (ComponentChange c : cc) {
            changeListForComponent.add(c);
        }
    }


    public static Map getComponentToChangesMapForView(FacesContext facesContext,
                                                String viewId,
                                                boolean createIfNecessary) {
        Map sessMap = facesContext.getExternalContext().getSessionMap();
        Map viewToChangesMap =
            (Map)sessMap.get("org.apache.myfaces.trinidadinternal.Change");
        if (viewToChangesMap == null) {
            if (!createIfNecessary)
                return null;
            viewToChangesMap = new ConcurrentHashMap();
            sessMap.put("org.apache.myfaces.trinidadinternal.Change",
                        viewToChangesMap);
        }
        Map componentToChangesMap = (Map)viewToChangesMap.get(viewId);
        if (componentToChangesMap == null) {
            if (!createIfNecessary)
                return null;
            componentToChangesMap = new ConcurrentHashMap();
            viewToChangesMap.put(viewId, componentToChangesMap);
        }
        return componentToChangesMap;
    }


    public String reportAllComponentChangesForCurrentPage() {
        reportAllComponentChangesForPage(FacesContext.getCurrentInstance().getViewRoot().getViewId());
        return null;
    }

    public void reportAllComponentChangesForPage(String viewId) {
        SessionChangeManager cm = new SessionChangeManager();
        Map changeMap =
            (Map)FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("org.apache.myfaces.trinidadinternal.Change");


        Map changesForViewMap = (Map)changeMap.get(viewId);
        Iterator<String> compIds = changesForViewMap.keySet().iterator();

        if (compIds != null)
            while (compIds.hasNext()) {
                String compId = compIds.next();
                List<ComponentChange> changes =
                    (List<ComponentChange>)changesForViewMap.get(compId);

                if (changes != null)
                    System.out.println("");
                System.out.println("* Changes for " + compId);
                System.out.println("-------------------------------------");
                for (ComponentChange cc : changes) {

                    if (cc instanceof AttributeComponentChange) {
                        System.out.println(((AttributeComponentChange)cc).getAttributeName() +
                                           " = " +
                                           ((AttributeComponentChange)cc).getAttributeValue());
                    }
                }
            }
    }

    /**
     * All pages
     */
    public void reportAllComponentChanges() {
        Map changeMap =
            (Map)FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("org.apache.myfaces.trinidadinternal.Change");

        Iterator allPages = changeMap.keySet().iterator();
        while (allPages.hasNext()) {
            String pageId = (String)allPages.next();
            System.out.println("All persistent changes for page " + pageId);
            System.out.println("===============================================");
            reportAllComponentChangesForPage(pageId);
        }
    }

    private void clearAllPersistentChanges() {
        Map changeMap =
            (Map)FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("org.apache.myfaces.trinidadinternal.Change");
changeMap.clear();
        Iterator allPages = changeMap.keySet().iterator();
        while (allPages.hasNext()) {
            String pageId = (String)allPages.next();
            System.out.println("Remove changes for page "+pageId);
            Map componentToChangesMap = new ConcurrentHashMap();
            changeMap.put(pageId, componentToChangesMap);
            System.out.println("Set flag in viewsProcessed to false for "+pageId);
            viewsProcessed.put(pageId,
                               Boolean.FALSE);          
        }
    }

    
}
